#include <Wire.h> 
#include <LiquidCrystal_I2C.h>

LiquidCrystal_I2C lcd(0x27,16, 2);

int timer1;
int timer2;

float Time;

int flag1 = 0;
int flag2 = 0;

float distance = 5.0;
float speed;

int ir_s1 = A0;
int ir_s2 = A1;

int buzzer = 13;
int red_led = 12;
int blue_led = 11;

void setup(){
  pinMode(ir_s1, INPUT);
  pinMode(ir_s2, INPUT);
  pinMode(buzzer, OUTPUT);
  pinMode(red_led, OUTPUT);
  pinMode(blue_led, OUTPUT);

  lcd.init();
  lcd.backlight();
  lcd.setCursor(0,0);
  lcd.print(" WELCOME To  My ");
  lcd.setCursor(0,1);
  lcd.print("Arduino Project");
  delay(4000);
  lcd.clear();
}

void loop() {
  if(digitalRead (ir_s1) == LOW && flag1==0){
    timer1 = millis(); 
    flag1=1;
  }

  if(digitalRead (ir_s2) == LOW && flag2==0){
    timer2 = millis(); 
    flag2=1;
  }
  
  if (flag1==1 && flag2==1){
    if(timer1 > timer2){
      Time = timer1 - timer2;
    }
    else if(timer2 > timer1){
      Time = timer2 - timer1;
    }
    Time=Time/1000;
    speed=(distance/Time);
    speed=speed*3600;
    speed=speed/1000;
  }
  
  if(speed==0){ 
    lcd.setCursor(0, 1); 
    if(flag1==0 && flag2==0){
      lcd.print("No car  detected");
    }
    else{
      lcd.print("Searching...    ");
    } 
  }
  else{
    lcd.clear(); 
    lcd.setCursor(0, 0); 
    lcd.print("Speed:");
    lcd.print(speed,1);
    lcd.print("Km/Hr  ");
    lcd.setCursor(0, 1); 
    if(speed > 50){
      lcd.print("  Over Speeding  ");
      siren();
    }
    else{
      lcd.print("  Normal Speed   "); 
    }    
    delay(1000);
    speed = 0;
    flag1 = 0;
    flag2 = 0;    
  }
}

void siren() {
  digitalWrite(buzzer, HIGH);
  int i;
  for (i = 0; i < 5; i++) {
    digitalWrite(red_led, HIGH);
    delay(250);
    digitalWrite(red_led, LOW);
    digitalWrite(blue_led, HIGH);
    delay(250);
    digitalWrite(blue_led, LOW);
  }
  digitalWrite(buzzer, LOW);
  digitalWrite(red_led, LOW);
  digitalWrite(blue_led, LOW);
}
